/// Wrapper for `Exception` or `Error` with `StackTrace` (if it have been provided)
class PackageException {
  /// Inner exception, might be null if `PackageException` have been created `fromError`
  final Exception innerException;

  /// Inner error, might be null if `PackageException` have been created `fromException`
  final Error innerError;

  /// Current `StackTrace`, if provided
  final StackTrace stackTrace;

  /// Gets current `Exception` or `Error`
  dynamic get currentException => innerException ?? innerError;

  /// Ctor for wrapping `Exception`
  PackageException.fromException(this.innerException, [this.stackTrace])
      : innerError = null;

  /// Ctor for wrapping `Error`
  PackageException.fromError(this.innerError, [this.stackTrace])
      : innerException = null;
}
